﻿@model Jb.Framework.Common.Forms.JbSignature
@using Jb.Framework.Common.Forms
@using Jb.Framework.Common.Forms.Validation
@using Jumbula.Common.Helper
@{

    var htmlAttributes = new Dictionary<string, object>();
    var cssClasses = new List<string>();

    var width = "element_width-third";
    switch (Model.Width)
    {
        case ElementWidth.Half:
            {
                width = "element_width-half";
            }
            break;
        case ElementWidth.Full:
            {
                width = "element_width-full";
            }
            break;
    }

    cssClasses.Add(Model.Size.ToDescription());
    if (cssClasses.Any())
    {
        htmlAttributes.Add("class", string.Join(",", cssClasses) + " form-control");
    }

    htmlAttributes.Add("data-clientid", Model.Name);
    if (Model.CurrentMode != AccessMode.Design)
    {
        if (Model.IsRequired || Model.Validations.Any(x => x.Type != ElementValidationType.None))
        {
            htmlAttributes.Add("data-val", "true");
        }
        if (Model.Validations.Any(x => x.Type == ElementValidationType.Required))
        {
            htmlAttributes.Add("data-val-Required", Model.Validations.First(x => x.Type == ElementValidationType.Required).Message);
        }
        else if (Model.IsRequired)
        {
            htmlAttributes.Add("data-val-Required", Model.Title + " is required.");
        }

        if (Model.CurrentMode == AccessMode.ReadOnly)
        {
            htmlAttributes.Add("ReadOnly", true);
        }
        //textBoxHtmlAttr.Add("data-error", Html.ValidationMessageForText(model => model.Value));
    }

}
@if (Model.CurrentMode == AccessMode.Print)
{
    <div class="form-group JbFormControll JbSignature clearfix @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
        @for (var i = 0; i < Model.Validations.Count; i++)
        {
            //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
            var hiddnModelBindername = "Validations[" + i + "].QVModelType";
            @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

            @Html.HiddenFor(x => x.Validations[i].IsChecked)
            @Html.HiddenFor(x => x.Validations[i].Type)
            @Html.HiddenFor(x => x.Validations[i].Message)
        }
        @Html.GenerateHiddenFields(Model)
        @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
        @if (!string.IsNullOrEmpty(Model.HelpText))
        {
            <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
        }
        @{
            htmlAttributes.Add("id", Model.ElementId + "_Value");
        }
        @Html.HiddenFor(m => m.Value, htmlAttributes)
        <div id="@Model.ElementId" class="sign-container">
            @Html.ValidationMessageFor(model => model.Value)
        </div>
    </div>
            }
            else
            {
                <div class="form-group JbFormControll JbSignature clearfix @width" style="display: @(Model.VisibleMode != VisibilityMode.Both && Model.VisibleMode != (VisibilityMode)ViewBag.VisibleMode ? "none" : "block")">
                    @for (var i = 0; i < Model.Validations.Count; i++)
                    {
                        //Custom model binder require full model name , i add Validations[i] at the end of string that mvc generate
                        var hiddnModelBindername = "Validations[" + i + "].QVModelType";
                        @Html.Hidden(hiddnModelBindername, Model.Validations[i].GetType())

                        @Html.HiddenFor(x => x.Validations[i].IsChecked)
                        @Html.HiddenFor(x => x.Validations[i].Type)
                        @Html.HiddenFor(x => x.Validations[i].Message)
                    }
                    @Html.GenerateHiddenFields(Model)
                    @Html.LabelFor(m => m.Value, Model.Title, new { @class = (Model.Validations.Any(t => t.Type == ElementValidationType.Required) || Model.IsRequired) ? "req" : "" })
                    @if (!string.IsNullOrEmpty(Model.HelpText))
                    {
                        <a href="#" class="help" role="button" data-toggle="popover" data-trigger="focus" data-content="@Model.HelpText"></a>
                    }
                    @{
                        htmlAttributes.Add("id", Model.ElementId + "_Value");
                    }
                    @Html.HiddenFor(m => m.Value, htmlAttributes)
                    <div id="@Model.ElementId" class="sign-container">
                        <button data-for="@Model.ElementId" class="btn btn-default btn-sm pull-right clear-signature">Clear</button>
                        @Html.ValidationMessageFor(model => model.Value, "Signature is required.", new { style = "color:white; top: 0" })
                    </div>
                </div>
                        }

<script src="~/Scripts/Libraries/jSignature/jSignature.min.js"></script>

<script type="text/javascript">
    function showAllParents(element) {
        $(element).parents().each(function () {
            var oldDisplay = $(this).css("display");
            if (oldDisplay == "none") {
                $(this).data("old-display", oldDisplay).css("display", "block")
            }
        });
    }
    function hideAllParents(element) {
        $(element).parents().each(function () {
            if ($(this).data("old-display") == "none") {
                $(this).css("display", "")
            }
        });
    }

    showAllParents("#" + "@Model.ElementId");
    $("#" + "@Model.ElementId").jSignature({
        lineWidth: 1,
        height: 120,
        width: $("#" + "@Model.ElementId").outerWidth() - 2
    }).bind('change', function (e) {
        $('.clear-signature[data-for="@Model.ElementId"]').show(0);
        $("#" + "@Model.ElementId" + "_Value").val($(this).jSignature("getData", "base30"));
    });
    hideAllParents("#" + "@Model.ElementId");

    $('.clear-signature[data-for="@Model.ElementId"]').click(function (event) {
        event.preventDefault();
        $("#" + $(this).attr("data-for")).jSignature('clear');
    }).hide(0);

    @if (string.IsNullOrEmpty(Model.Value) == false && Model.Value != "image/jsignature;base30,")
    {
        <text>
    $("#" + "@Model.ElementId").jSignature("setData", "@(Model.Value)", "base30");
    </text>
        }
</script>
